/**
 * @author diverKon <diverKon@gmail.com>
 * @license http://www.opensource.org/licenses/bsd-license.php
 */
package jp.ne.sakura.kkkon.yamahart;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

/**
 *
 */
public class Account
{
    public static final String DEFAULT_FILENAME = "account.properties";

    protected   String      hostname;
    protected   String      username;
    protected   String      passwordLogin;
    protected   String      passwordAdmin;

    /**
     * @return the hostname
     */
    public String getHostname() {
        return this.hostname;
    }

    /**
     * @return the username
     */
    public String getUsername() {
        return this.username;
    }

    /**
     * @return the passwordLogin
     */
    public String getPasswordLogin() {
        return this.passwordLogin;
    }

    /**
     * @return the passwordAdmin
     */
    public String getPasswordAdmin() {
        return this.passwordAdmin;
    }

    public void loadFromProperties( final String filename )
    {
//        {
//            final java.util.Properties prop = System.getProperties();
//            for ( Object k : prop.keySet() )
//            {
//                String key = (String)k;
//                String val = System.getProperty( key );
//                System.out.println( key + "=" + val );
//            }
//        }
//        {
//            final java.io.File file = new java.io.File(".");
//            System.out.println( "cur_dir=" + file.getAbsolutePath() );
//        }

        InputStream inStream = this.getClass().getResourceAsStream( filename );
        
        if ( null == inStream )
        {
            try
            {
                inStream = new FileInputStream( filename );
            }
            catch ( FileNotFoundException e )
            {
                e.printStackTrace( System.err );
            }
        }

        String prop_hostname = null;
        String prop_username = null;
        String prop_passwordLogin = null;
        String prop_passwordAdmin = null;

        if ( null != inStream )
        {
            Properties prop = new Properties();
            try
            {
                prop.load( inStream );
            }
            catch ( IOException e )
            {
                e.printStackTrace( System.err );
                prop = null;
            }

            if ( null != prop )
            {
                prop_hostname = prop.getProperty( "hostname" );
                prop_username = prop.getProperty( "username" );
                prop_passwordLogin = prop.getProperty( "passwordLogin" );
                prop_passwordAdmin = prop.getProperty( "passwordAdmin" );
            }
        }

        if ( null != inStream )
        {
            try
            {
                inStream.close();
            }
            catch ( IOException e )
            {
                e.printStackTrace( System.err );
            }
            finally
            {
                inStream = null;
            }
        }

        this.hostname = prop_hostname;
        this.username = prop_username;
        this.passwordLogin = prop_passwordLogin;
        this.passwordAdmin = prop_passwordAdmin;

    }

}
